local Keys = {
  ["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57,
  ["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177,
  ["TAB"] = 37, ["Q"] = 44, ["W"] = 32, ["E"] = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
  ["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
  ["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
  ["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70,
  ["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
  ["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
  ["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}
local inCamera = false
local inVCamera = false
local inPCamera = false
local inCameraView = false
local inSelfieMode = false

local cam = nil

local fov_max = 90.0
local fov_min = 5.0 -- max zoom level (smaller fov is more zoom)
local fov = (fov_max+fov_min)*0.5
local zoomspeed = 1.0 -- camera zoom speed
local speed_lr = 4.0 -- speed by which the camera pans left-right 
local speed_ud = 4.0 -- speed by which the camera pans up-down

local ped = 0

local inAnimation = false
local camera = nil

local debug = false

RegisterNetEvent('camera:camera')
AddEventHandler('camera:camera', function(message)	
	if inCamera == false then				
		if camera == nil then
			local pedHoldingWeapon = IsPedArmed(GetPlayerPed(-1), 7)
		    if pedHoldingWeapon then
		        SetCurrentPedWeapon(GetPlayerPed(-1), 0xA2719263, true)		        
		    end
			enterCamera(ped, "camera")			
		end
	else		
		exitCamera(ped, "camera")
	end
end)

RegisterNetEvent('camera:videocamera')
AddEventHandler('camera:videocamera', function(message)	
	if inVCamera == false then					
		if camera == nil then
			local pedHoldingWeapon = IsPedArmed(GetPlayerPed(-1), 7)
		    if pedHoldingWeapon then
		        SetCurrentPedWeapon(GetPlayerPed(-1), 0xA2719263, true)		        
		    end
			enterCamera(ped, "videocamera")			
		end
	else	
		exitCamera(ped, "videocamera")
	end
end)

RegisterNetEvent('camera:phonecamera')
AddEventHandler('camera:phonecamera', function(message)	
	if inPCamera == false then					
		if camera == nil then
			local pedHoldingWeapon = IsPedArmed(GetPlayerPed(-1), 7)
		    if pedHoldingWeapon then
		        SetCurrentPedWeapon(GetPlayerPed(-1), 0xA2719263, true)		        
		    end
			enterCamera(ped, "phonecamera")			
		end
	else	
		exitCamera(ped, "phonecamera")
	end
end)

Citizen.CreateThread(function ()	
	while true do
		Citizen.Wait(0)
		ped =  GetPlayerPed(-1)

		if (inCamera or inVCamera or inPCamera) and inAnimation == false then
			SetTextComponentFormat('STRING')
			AddTextComponentString("press ~INPUT_CONTEXT~ to enter camera view.")
			DisplayHelpTextFromStringLabel(0, 0, 1, -1)
			if IsControlJustPressed(1, Keys["E"]) and inCameraView == false then				
				inCameraView = true
				enterCameraView()				
			end

			DisableControlAction(0,12,true) -- disable weapon select
			DisableControlAction(0,13,true) -- disable weapon select
			DisableControlAction(0,14,true) -- disable weapon select
			DisableControlAction(0,15,true) -- disable weapon select
			DisableControlAction(0,16,true) -- disable weapon select
			DisableControlAction(0,17,true) -- disable weapon select

			DisableControlAction(0,24,true) -- disable attack
			DisableControlAction(0,25,true) -- disable aim
			DisableControlAction(0,47,true) -- disable weapon
			DisableControlAction(0,58,true) -- disable weapon
			DisableControlAction(0,263,true) -- disable melee
			DisableControlAction(0,264,true) -- disable melee
			DisableControlAction(0,257,true) -- disable melee
			DisableControlAction(0,140,true) -- disable melee
			DisableControlAction(0,141,true) -- disable melee
			DisableControlAction(0,142,true) -- disable melee
			DisableControlAction(0,143,true) -- disable melee
			DisableControlAction(0,49,true) -- disable interaction
			DisableControlAction(0,23,true) -- disable interaction


			DisableControlAction(0,75,true) -- disable interaction

			DisableControlAction(0,68,true) -- disable interaction
			DisableControlAction(0,69,true) -- disable interaction
			DisableControlAction(0,70,true) -- disable interaction

			DisableControlAction(0,91,true) -- disable interaction
			DisableControlAction(0,92,true) -- disable interaction

			if IsControlJustPressed(1, Keys["BACKSPACE"]) then
				if inCameraView and inPCamera and inSelfieMode == false then
					enterSelfie(ped, "phonecamera")
				elseif inCameraView then
					exitCameraView()
				else
					if inCamera or inVCamera then
						exitCamera(ped, "camera")
					elseif inPCamera then
						exitCamera(ped,"phonecamera")
					end					
				end
			end
	
			if IsPedInAnyVehicle(ped, false) == 1 or IsPedInAnyVehicle(ped, false) == true then
				DisableControlAction(0,71,true) -- disable vehicle throttle
				DisableControlAction(0,72,true) -- disable vehicle brake
				DisableControlAction(0,59,true) -- disable wheel turn
				DisableControlAction(0,60,true) -- disable up down (planes?)
			end

		end

		if inCameraView then
			DisableControlAction(0,30,true)
			DisableControlAction(0,31,true)

			HandleZoom(cam)
			HideHUDThisFrame()
			local zoomvalue = (1.0/(fov_max-fov_min))*(fov-fov_min)
			CheckInputRotation(cam, zoomvalue)
		end
	end
end)

Citizen.CreateThread(function()
	RequestAnimDict("amb@world_human_paparazzi@male@enter")
	RequestAnimDict("amb@world_human_paparazzi@male@base")	
	RequestAnimDict("amb@world_human_paparazzi@male@exit")
	RequestAnimDict("amb@world_human_paparazzi@male@idle_a")
	RequestAnimDict("missfinale_c2mcs_1")
	RequestAnimDict("cellphone@")
	RequestAnimDict("move_action@generic@core")
	RequestAnimDict("amb@code_human_in_car_idles@generic@rps@base")
end)

function enterCameraView()
	cam = CreateCam("DEFAULT_SCRIPTED_FLY_CAMERA", true)
	if inCamera then
		if not IsPedInAnyVehicle(ped, false) then
			playAnimation(ped, "amb@world_human_paparazzi@male@base", "base", false, true, false)
		end
		AttachCamToEntity(cam, ped, 0.0,0.8,0.6, true)
	end

	if inVCamera then
		if not IsPedInAnyVehicle(ped, false) then
			playAnimation(ped, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman", false, true, false)
		end
		AttachCamToEntity(cam, ped, 0.06,0.48,0.53, true)
	end

	if inPCamera then	
		if not IsPedInAnyVehicle(ped, false) then	
			playAnimation(ped, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman", false, false, false)
		end
		AttachCamToEntity(cam, ped, 0.0,0.65,0.55, true)	
	end

	if IsPedInAnyVehicle(ped, false) then
		AttachCamToEntity(cam, ped, 0.0,-0.2,0.6, true)
	end

	SetCamRot(cam, 0.0,0.0,GetEntityHeading(ped)+0)
	SetCamFov(cam, fov)
	RenderScriptCams(true, false, 0, 1, 0)
	TriggerEvent('es:setMoneyDisplay', 0.0)	
	TriggerEvent('es:setBankDisplay', 0.0)	
	inCameraView = true
end

function exitCameraView()
	if not IsPedInAnyVehicle(ped, false) then
		ClearPedTasksImmediately(ped)			
	end
	if inCamera then
		playAnimation(ped, "amb@world_human_paparazzi@male@base", "base", true, true, true)		
	end
	if inVCamera then
		playAnimation(ped, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman", true, true, true)
	end
	if inPCamera then
		playAnimation(ped, "cellphone@", "cellphone_photo_idle", true, true, true)
	end
	RenderScriptCams(false, false, 0, 1, 0)
	TriggerEvent('es:setMoneyDisplay', 1.0)
	TriggerEvent('es:setBankDisplay', 1.0)	
	DestroyCam(cam, false)
	inCameraView = false
	inSelfieMode = false
end

function enterCamera(p, t)
	local a = true
	inAnimation = true
	SetCinematicButtonActive(false)
	if t == "camera" then
		inCamera = true
		RequestModel("prop_pap_camera_01")
		while not HasModelLoaded("prop_pap_camera_01") do
	       Wait(1)
	    end
	    playAnimation(ped, "amb@world_human_paparazzi@male@enter", "enter", true, false, true)
	    if not IsPedInAnyVehicle(p, false) then
	    	while a do
				Wait(0)
				if GetEntityAnimCurrentTime(p, "amb@world_human_paparazzi@male@enter", "enter") == 1.0  then
					--playAnimation(ped, "amb@world_human_paparazzi@male@base", "base", true, false, true)
					inAnimation = false
					a = false
				elseif GetEntityAnimCurrentTime(p, "amb@world_human_paparazzi@male@enter", "enter") > 0.30  and camera == nil then			
					local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
				    camera = CreateObject("prop_pap_camera_01", x, y, z, true, true, true)			       
				    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.12, 0.0, -0.025, -15.0, 90.0, 50.0, false, false, false, false, 2, true)			        		    		
				end		 
			end 
	    else
	    	local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
		    camera = CreateObject("prop_pap_camera_01", x, y, z, true, true, true)			       
		    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.12, 0.0, -0.025, -15.0, 90.0, 50.0, false, false, false, false, 2, true)	
			inAnimation = false
			a = false	
	    end


	elseif t == "videocamera" then
		inVCamera = true
		RequestModel("prop_v_cam_01")
		while not HasModelLoaded("prop_v_cam_01") and not GetIsTaskActive(p, 165) do
           Wait(1)
        end
        playAnimation(ped, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman", true, false, true)
		if not IsPedInAnyVehicle(p, false) then	
			local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
			camera = CreateObject("prop_v_cam_01", x, y, z, true, true, true)			       
			AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.15, 0.25, -0.065, -80.0, 0.0, -75.0, false, false, false, false, 2, true)			
			while a do
				Wait(0)		
				if GetEntityAnimCurrentTime(p, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman") > 0.003  then									
					SetEntityAnimCurrentTime(p, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman",0.003)
					inAnimation = false					
				elseif GetEntityAnimCurrentTime(p, "missfinale_c2mcs_1", "fin_c2_mcs_1_camman") == 0.0 then
					a = false
				end	 
			end 
		else
			local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
			camera = CreateObject("prop_v_cam_01", x, y, z, true, true, true)			       
			AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.15, 0.25, -0.065, -80.0, 0.0, -75.0, false, false, false, false, 2, true)			
			a = false
			inAnimation = false		
		end


	elseif t == "phonecamera" then
		inPCamera = true
		local switchHands = false
		RequestModel("prop_player_phone_02")
		while not HasModelLoaded("prop_player_phone_02") do
           Wait(1)
        end     
		playAnimation(ped, "cellphone@", "cellphone_photo_ent", true, false, true)
		
		if not IsPedInAnyVehicle(p, false) then	
			while a do
				Wait(0)
				if GetEntityAnimCurrentTime(p, "cellphone@", "cellphone_photo_ent") == 1.0  then				
					--playAnimation(ped, "cellphone@", "cellphone_photo_idle", true, true, true)
					inAnimation = false
					a = false				
				elseif GetEntityAnimCurrentTime(p, "cellphone@", "cellphone_photo_ent") > 0.70 and switchHands == false then
					switchHands = true
					DeleteEntity(camera)
					local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
				    camera = CreateObject("prop_player_phone_02", x, y, z, true, true, true)			       
				    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 18905), 0.163,0.041,0.033,-20.0,-54.0,208.0, false, false, false, false, 2, true)   -- u/d, f/b, l/r -- l/r,   
				elseif GetEntityAnimCurrentTime(p, "cellphone@", "cellphone_photo_ent") > 0.20  and camera == nil then			
					local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
				    camera = CreateObject("prop_player_phone_02", x, y, z, true, true, true)			       
				    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.15, 0.02, -0.02, 80.0, 35.0, -110.0, false, false, false, false, 2, true)   -- u/d, f/b, l/r -- l/r,         		    		
				end
			end
		else
			local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
		    camera = CreateObject("prop_player_phone_02", x, y, z, true, true, true)			       
		    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 18905), 0.163,0.041,0.033,-20.0,-54.0,208.0, false, false, false, false, 2, true)   -- u/d, f/b, l/r -- l/r, 
		    inAnimation = false
			a = false	
		end
	end
end

function exitCamera(p, t)
	local a = true
	inAnimation = true
	if t == "camera" or  t == "videocamera" then
		if not IsPedInAnyVehicle(ped, false) then
			playAnimation(p, "amb@world_human_paparazzi@male@exit", "exit", false, false, true)
			while a do
				Wait(0)
				if GetEntityAnimCurrentTime(p, "amb@world_human_paparazzi@male@exit","exit") > 0.90  then
					ClearPedTasksImmediately(ped)
					inAnimation = false
					a = false
				elseif GetEntityAnimCurrentTime(p, "amb@world_human_paparazzi@male@exit","exit") > 0.50  then			
					DeleteEntity(camera)
					camera = nil
				end
			end
		else
			DeleteEntity(camera)
			camera = nil	
			local v = GetVehiclePedIsIn(p, false)
			local seat =getSeatPedIsIn(p)
			ClearPedTasksImmediately(p)
			TaskWarpPedIntoVehicle(p, v, seat)
		end		
	elseif t == "phonecamera" then
		if not IsPedInAnyVehicle(ped, false) then
			local switchHands = false
			playAnimation(p, "cellphone@", "cellphone_photo_exit", true, false, true)
			while a do
				Wait(0)
				if GetEntityAnimCurrentTime(p, "cellphone@","cellphone_photo_exit") > 0.90  then				
					ClearPedTasksImmediately(p)	
					inAnimation = false
					a = false
				elseif GetEntityAnimCurrentTime(p, "cellphone@","cellphone_photo_exit") > 0.80 then
					DeleteEntity(camera)
					camera = nil
				elseif GetEntityAnimCurrentTime(p, "cellphone@","cellphone_photo_exit") > 0.20  and switchHands == false then
					swtichHands = true
					DeleteEntity(camera)
					local x, y, z = table.unpack(GetEntityCoords(GetPlayerPed(-1), true))
				    camera = CreateObject("prop_player_phone_02", x, y, z, true, true, true)			       
				    AttachEntityToEntity(camera, ped, GetPedBoneIndex(ped, 57005), 0.15, 0.02, -0.02, 80.0, 35.0, -110.0, false, false, false, false, 2, true)   -- u/d, f/b, l/r -- l/r, 
				end		 
			end
		else
			DeleteEntity(camera)
			camera = nil	
			local v = GetVehiclePedIsIn(p, false)
			local seat =getSeatPedIsIn(p)
			ClearPedTasksImmediately(p)
			TaskWarpPedIntoVehicle(p, v, seat)
		end
	end
	Wait(1000)
	SetCinematicButtonActive(true)
	inCamera = false
	inVCamera = false
	inPCamera = false
end


function enterSelfie(p, t)	
	local a = true
	if inPCamera and t == "phonecamera" then
		DestroyCam(cam, false)
		cam = CreateCam("DEFAULT_SCRIPTED_FLY_CAMERA", true)
		AttachCamToEntity(cam, p, 0.0,0.4,0.65, true)
		SetCamRot(cam, -5.0,0.0,GetEntityHeading(p)+200)
		SetCamFov(cam, 80.0)
		RenderScriptCams(true, false, 0, 1, 0)
		inSelfieMode = true
	end
end

function CellFrontCamActivate(activate) -- Selfie Cam
	return Citizen.InvokeNative(0x2491A93618B7D838, activate)
end

function playAnimation(p, d, an, upperbody, loop, controllable)
	local flags = 0;
	if controllable then
		flags = flags + 32
	end
	if upperbody then
		flags = flags + 16
	end
	if loop then
		flags = flags + 1
	else
		flags = flags + 2
	end

	TaskPlayAnim(p,d,an, 8.0, 1, -1, flags, 1, 0, 0, 0)	
end

function HandleZoom(cam)
	if inSelfieMode == false then
		if IsControlPressed(0,32) then -- Scrollup
			fov = math.max(fov - zoomspeed, fov_min)
		end
		if IsControlPressed(0,33) then
			fov = math.min(fov + zoomspeed, fov_max) -- ScrollDown		
		end
		local current_fov = GetCamFov(cam)
		if math.abs(fov-current_fov) < 0.1 then -- the difference is too small, just set the value directly to avoid unneeded updates to FOV of order 10^-5
			fov = current_fov
		end
		SetCamFov(cam, current_fov + (fov - current_fov)*0.05) -- Smoothing of camera zoom
		SetUseHiDof()	
	else
		SetUseHiDof()		
	end
end

function CheckInputRotation(cam, zoomvalue)
	local rightAxisX = GetDisabledControlNormal(0, 220)
	local rightAxisY = GetDisabledControlNormal(0, 221)
	local rotation = GetCamRot(cam, 2)
	if not IsPedInAnyVehicle(ped, false) then	
		if rightAxisX ~= 0.0 or rightAxisY ~= 0.0 then		
			if inSelfieMode then
				new_z = rotation.z + rightAxisX*-1.0*(speed_ud)
				new_x = -0.0			
				SetCamRot(cam, -5.0, 0.0, new_z, 2)
				SetEntityRotation(ped, 0.0, 0.0, new_z+160, 2, nil)
			else
				new_z = rotation.z + rightAxisX*-1.0*(speed_ud)*(zoomvalue+0.1)
				new_x = math.max(math.min(20.0, rotation.x + rightAxisY*-1.0*(speed_lr)*(zoomvalue+0.1)), -89.5) -- Clamping at top (cant see top of heli) and at bottom (doesn't glitch out in -90deg)
				SetCamRot(cam, new_x, 0.0, new_z, 2)
				SetEntityRotation(ped, 0.0, 0.0, new_z, 2, nil)
			end		
		end
	else
		if not inSelfieMode then
			SetEntityLocallyInvisible(ped)
			SetEntityLocallyInvisible(camera)
		end
		local bone = GetPedBoneIndex(ped, 57597)
		if rightAxisX ~= 0.0 or rightAxisY ~= 0.0 then
			if inSelfieMode then
				new_z = rotation.z + rightAxisX*-1.0*(speed_ud)
				new_x = -0.0			
				SetCamRot(cam, -5.0, 0.0, new_z, 2)
				SetEntityRotation(ped, 0.0, 0.0, new_z+160, 2, nil)
			else
				new_z = rotation.z + rightAxisX*-1.0*(speed_ud)*(zoomvalue+0.1)
				new_x = math.max(math.min(20.0, rotation.x + rightAxisY*-1.0*(speed_lr)*(zoomvalue+0.1)), -20.0) -- Clamping at top (cant see top of heli) and at bottom (doesn't glitch out in -90deg)
				SetCamRot(cam, new_x, 0.0, new_z, 2)
				SetEntityRotation(bone, 0.0, 0.0, new_z, 2, nil)
			end		
		end
	end
end

function HideHUDThisFrame()	
	HideHelpTextThisFrame()
	HideHudAndRadarThisFrame()	
	HideHudComponentThisFrame(1) -- Wanted Stars
	HideHudComponentThisFrame(2) -- Weapon icon
	HideHudComponentThisFrame(3) -- Cash
	HideHudComponentThisFrame(4) -- MP CASH
	HideHudComponentThisFrame(5) -- mp message
	HideHudComponentThisFrame(6) -- vehicle name
	HideHudComponentThisFrame(7) -- area name
	HideHudComponentThisFrame(8) -- vehicle class
	HideHudComponentThisFrame(9) -- street name
	HideHudComponentThisFrame(10) -- Help Text	
	HideHudComponentThisFrame(11) -- Floating Help Text
	HideHudComponentThisFrame(12) -- more floating help text
	HideHudComponentThisFrame(13) -- Cash Change
	HideHudComponentThisFrame(14) -- reticle
	HideHudComponentThisFrame(16) -- radio stations
	HideHudComponentThisFrame(17) -- saving game
	HideHudComponentThisFrame(18) -- Game Stream
	HideHudComponentThisFrame(19) -- weapon wheel
	HideHudComponentThisFrame(20) -- weapon wheel stats
end

function getSeatPedIsIn(p)
	local v =  GetVehiclePedIsIn(p, false)
	if v ~= 0 and v ~= nil then
		local numSeats = GetVehicleModelMaxNumberOfPassengers(GetEntityModel(v))
		for i=-1,(numSeats - 2) do
			if p == GetPedInVehicleSeat(v, i) then
				return i
			end			
		end
	end	
	return false
end